
local Message, MessageLing, MessageInfo, InfoDaily, InfoType
local objCSaved = {}
local EntriesSaved, QuestsSaved, questIndex, boardIndex
MyAddon = LibStub("AceAddon-3.0"):NewAddon("Objective Announcer", "AceEvent-3.0", "AceConsole-3.0")
local defaults = {
	profile = {
		quest = 1,
		party = 1,
		raid = 0,
		guild = 0,
		officer = 0,
		info = 1
	}
}


function MyAddon:OnEnable()
local function eventHandler(event, ...)
	local numEntries, numQuests = GetNumQuestLogEntries()
	if numEntries ~= EntriesSaved or numQuests ~= QuestsSaved then
		EntriesSaved = numEntries
		QuestsSaved = numQuests
		for questIndex = 1, EntriesSaved do
			local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex)
			if isHeader ~= 1 then
				for boardIndex = 1, GetNumQuestLeaderBoards(questIndex) do
					local objDesc, objType, objComplete = GetQuestLogLeaderBoard(boardIndex, questIndex)
					objCSaved[questIndex][boardIndex] = objComplete
				end
			end
		end
	else
		for questIndex = 1, numEntries do
			local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex)
			if isHeader ~= 1 then
				for boardIndex = 1, GetNumQuestLeaderBoards(questIndex) do
					local objDesc, objType, objComplete = GetQuestLogLeaderBoard(boardIndex, questIndex)
					if (objComplete) and objComplete ~= objCSaved[questIndex][boardIndex] then
						if self.db.profile.quest == 1 then
							local link = GetQuestLink(questIndex)
							MessageLink = strjoin("", "  --  ", link)
						else
							MessageLink = ""
						end
						if self.db.profile.info == 1 then
							if (isDaily) then
								InfoDaily = "Daily"
							else
								InfoDaily = ""
							end
							local temp = tostring(level)
							InfoLevel = strjoin("", "[", temp, "]")
							if (questTag) then
								InfoType = questTag
							else
								InfoType = ""
							end
							MessageInfo = strjoin(" ", "  -- ", InfoType, InfoDaily, InfoLevel)
						else
							MessageInfo = ""
						end
						Message = strjoin("", objDesc, MessageLink, MessageInfo)
						if self.db.profile.raid == 1 and GetNumRaidMembers() > 0 then
							SendChatMessage(Message, "RAID", nil, nil)
						elseif self.db.profile.party == 1 and GetNumPartyMembers() > 0 then
							SendChatMessage(Message, "PARTY", nil, nil)
						end
						if self.db.profile.guild == 1 and (IsInGuild()) then
							SendChatMessage(Message, "GUILD", nil, nil)
						elseif self.db.profile.officer == 1 and (IsInGuild()) then
							SendChatMessage(Message, "OFFICER", nil, nil)
						end
					end
					objCSaved[questIndex][boardIndex] = objComplete
				end
			end
		end
	end
end
MyAddon:RegisterEvent("QUEST_LOG_UPDATE", eventHandler);
local function commandHandler(str)
	local Channel, Toggle = MyAddon:GetArgs(str, 2, 1)
	if Channel == "quest" then
		if Toggle == "off" then
			self.db.profile.quest = 0
		elseif Toggle == "on" then
			self.db.profile.quest = 1
		end
	elseif Channel == "info" then
		if Toggle == "off" then
			self.db.profile.info = 0
		elseif Toggle == "on" then
			self.db.profile.info = 1
		end
	elseif Channel == "raid" then
		if Toggle == "off" then
			self.db.profile.raid = 0
		elseif Toggle == "on" then
			self.db.profile.raid = 1
		end
	elseif Channel == "party" then
		if Toggle == "off" then
			self.db.profile.party = 0
		elseif Toggle == "on" then
			self.db.profile.party = 1
		end
	elseif Channel == "guild" then
		if Toggle == "off" then
			self.db.profile.guild = 0
		elseif Toggle == "on" then
			self.db.profile.guild = 1
		end
	elseif Channel == "officer" then
		if Toggle == "off" then
			self.db.profile.officer = 0
		elseif Toggle == "on" then
			self.db.profile.officer = 1
		end
	end
	local str1 = ""
	local str2 = ""
	local str3 = ""
	local str4 = ""
	local str5 = ""
	local str6 = ""
	if self.db.profile.quest == 1 then
		str5 = "  --  Showing Quest Links"
	end
	if self.db.profile.info == 1 then
		str6 = "  --  Including Quest Info"
	end
	if self.db.profile.party == 0 and self.db.profile.raid == 0 and self.db.profile.guild == 0 and self.db.profile.officer == 0 then
		start = "Inactive - Add a Channel to Enable"
		str5 = ""
		str6 = ""
	else
		start = "Telling "
	end
	if self.db.profile.party == 1 then
		str1 = "Party "
	end
	if self.db.profile.raid == 1 then
		str2 = "Raid "
	end		
	if self.db.profile.guild == 1 then
		str3 = "Guild "
	end
	if self.db.profile.officer == 1 then
		str4 = "Officers "
	end		
	local active = strjoin("", "|cffcc33ffObjective Announcer\n\n", start, str1, str2, str3, str4, str5, str6, "\n\n/oa [quest/info/party/raid/guild/officer] [on/off]\n|r")
	DEFAULT_CHAT_FRAME:AddMessage(active)
end
MyAddon:RegisterChatCommand("oa", commandHandler);
end
function MyAddon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ObjectiveAnnouncerDB", defaults, true)
	for boardSaved = 1, 100 do
		objCSaved[boardSaved] = {}
	end
	EntriesSaved, QuestsSaved = GetNumQuestLogEntries()
	for questIndex = 1, EntriesSaved do
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex)
		if isHeader ~= 1 then
			for boardIndex = 1, GetNumQuestLeaderBoards(questIndex) do
				local objDesc, objType, objComplete = GetQuestLogLeaderBoard(boardIndex, questIndex)
				objCSaved[questIndex][boardIndex] = objComplete
			end
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cffcc33ffObjective Announcer v0.2.2 Loaded|r")
end


